diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/rfbproto.c vnc_unixsrc/vncviewer/rfbproto.c
--- vnc_unixsrc.orig/vncviewer/rfbproto.c	2008-09-05 19:51:24.000000000 -0400
+++ vnc_unixsrc/vncviewer/rfbproto.c	2010-04-17 22:34:38.000000000 -0400
@@ -459,58 +1152,406 @@
 static Bool
 PerformAuthenticationTight(void)
 {
-  rfbAuthenticationCapsMsg caps;
-  CARD32 authScheme;
-  int i;
+	rfbAuthenticationCapsMsg caps;
+	CARD32 authScheme;
+	int i;
 
-  /* In the protocol version 3.7t, the server informs us about supported
-     authentication schemes. Here we read this information. */
+	/* In the protocol version 3.7t, the server informs us about supported
+	authentication schemes. Here we read this information. */
 
-  if (!ReadFromRFBServer((char *)&caps, sz_rfbAuthenticationCapsMsg))
-    return False;
+	if (!ReadFromRFBServer((char *)&caps, sz_rfbAuthenticationCapsMsg)) {
+		return False;
+	}
 
-  caps.nAuthTypes = Swap32IfLE(caps.nAuthTypes);
+	caps.nAuthTypes = Swap32IfLE(caps.nAuthTypes);
 
-  if (!caps.nAuthTypes) {
-    fprintf(stderr, "No authentication needed\n");
-    return True;
-  }
+	if (!caps.nAuthTypes) {
+		fprintf(stderr, "No VNC authentication needed\n\n");
+		if (viewer_minor >= 8) {
+			CARD32 authResult;
+
+			if (!ReadFromRFBServer((char *)&authResult, 4)) {
+				return False;
+			}
+
+			authResult = Swap32IfLE(authResult);
+
+			if (authResult == rfbVncAuthOK) {
+				fprintf(stderr, "VNC authentication succeeded (%d) for PerformAuthenticationTight rfbSecTypeNone (RFB 3.8)\n", (int) authResult);
+			} else {
+				sprintf(msgbuf, "VNC authentication failed (%d) for PerformAuthenticationTight rfbSecTypeNone (RFB 3.8)\n\n", (int) authResult);
+				wmsg(msgbuf, 1);
+				return False;
+			}
+		}
+		return True;
+	}
 
-  if (!ReadCapabilityList(authCaps, caps.nAuthTypes))
-    return False;
+	if (!ReadCapabilityList(authCaps, caps.nAuthTypes)) {
+		return False;
+	}
 
-  /* Prefer Unix login authentication if a user name was given. */
-  if (appData.userLogin && CapsIsEnabled(authCaps, rfbAuthUnixLogin)) {
-    authScheme = Swap32IfLE(rfbAuthUnixLogin);
-    if (!WriteExact(rfbsock, (char *)&authScheme, sizeof(authScheme)))
-      return False;
-    return AuthenticateUnixLogin();
-  }
+	/* Prefer Unix login authentication if a user name was given. */
+	if (appData.userLogin && CapsIsEnabled(authCaps, rfbAuthUnixLogin)) {
+		authScheme = Swap32IfLE(rfbAuthUnixLogin);
+		if (!WriteExact(rfbsock, (char *)&authScheme, sizeof(authScheme))) {
+			return False;
+		}
+		return AuthenticateUnixLogin();
+	}
 
-  /* Otherwise, try server's preferred authentication scheme. */
-  for (i = 0; i < CapsNumEnabled(authCaps); i++) {
-    authScheme = CapsGetByOrder(authCaps, i);
-    if (authScheme != rfbAuthUnixLogin && authScheme != rfbAuthVNC)
-      continue;                 /* unknown scheme - cannot use it */
-    authScheme = Swap32IfLE(authScheme);
-    if (!WriteExact(rfbsock, (char *)&authScheme, sizeof(authScheme)))
-      return False;
-    authScheme = Swap32IfLE(authScheme); /* convert it back */
-    if (authScheme == rfbAuthUnixLogin) {
-      return AuthenticateUnixLogin();
-    } else if (authScheme == rfbAuthVNC) {
-      return AuthenticateVNC();
-    } else {
-      /* Should never happen. */
-      fprintf(stderr, "Assertion failed: unknown authentication scheme\n");
-      return False;
-    }
-  }
+	/* Otherwise, try server's preferred authentication scheme. */
+	for (i = 0; i < CapsNumEnabled(authCaps); i++) {
+		authScheme = CapsGetByOrder(authCaps, i);
+		if (authScheme != rfbAuthUnixLogin && authScheme != rfbAuthVNC) {
+			continue;                 /* unknown scheme - cannot use it */
+		}
+		authScheme = Swap32IfLE(authScheme);
+		if (!WriteExact(rfbsock, (char *)&authScheme, sizeof(authScheme))) {
+			return False;
+		}
+		authScheme = Swap32IfLE(authScheme); /* convert it back */
+		if (authScheme == rfbAuthUnixLogin) {
+			return AuthenticateUnixLogin();
+		} else if (authScheme == rfbAuthVNC) {
+			return AuthenticateVNC();
+		} else {
+			/* Should never happen. */
+			fprintf(stderr, "Assertion failed: unknown authentication scheme\n");
+			return False;
+		}
+	}
 
-  fprintf(stderr, "No suitable authentication schemes offered by server\n");
-  return False;
+	sprintf(msgbuf, "No suitable authentication schemes offered by server\n");
+	wmsg(msgbuf, 1);
+	return False;
+}
+
+#if 0
+unsigned char encPasswd[8];
+unsigned char encPasswd_MSLOGON[32];
+char clearPasswd_MSLOGIN[256];
+static Bool old_ultravnc_mslogon_code(void) {
+	char *passwd = NULL;
+	CARD8 challenge_mslogon[CHALLENGESIZE_MSLOGON];
+
+	/* code from the old uvnc way (1.0.2?) that would go into AuthenticateVNC() template */
+	
+	if (appData.msLogon != NULL) {
+		raiseme(1);
+		if (!strcmp(appData.msLogon, "1")) {
+			char tmp[256];
+			fprintf(stderr, "\nUltraVNC MS Logon Username[@Domain]: ");
+			if (fgets(tmp, 256, stdin) == NULL) {
+				exit(1);
+			}
+			appData.msLogon = strdup(tmp);
+		}
+		passwd = getpass("UltraVNC MS Logon Password: ");
+		if (! passwd) {
+			exit(1);
+		}
+		fprintf(stderr, "\n");
+
+		UvncEncryptPasswd_MSLOGON(encPasswd_MSLOGON, passwd);
+	}
+	if (appData.msLogon) {
+		if (!ReadFromRFBServer((char *)challenge_mslogon, CHALLENGESIZE_MSLOGON)) {
+			return False;
+		}
+	}
+	if (appData.msLogon) {
+		int i;
+		char tmp[256];
+		char *q, *domain = ".";
+		for (i=0; i < 32; i++) {
+			challenge_mslogon[i] = encPasswd_MSLOGON[i] ^ challenge_mslogon[i];
+		}
+		q = strchr(appData.msLogon, '@');
+		if (q) {
+			*q = '\0';
+			domain = strdup(q+1);
+		}
+		memset(tmp, 0, sizeof(tmp));
+		strcat(tmp, appData.msLogon);
+		if (!WriteExact(rfbsock, tmp, 256)) {
+			return False;
+		}
+		memset(tmp, 0, sizeof(tmp));
+		strcat(tmp, domain);
+		if (!WriteExact(rfbsock, tmp, 256)) {
+			return False;
+		}
+		memset(tmp, 0, sizeof(tmp));
+		strcat(tmp, passwd);
+		if (!WriteExact(rfbsock, tmp, CHALLENGESIZE_MSLOGON)) {
+			return False;
+		}
+	}
 }
+#endif
 
+static void hexprint(char *label, char *data, int len) {
+	int i;
+	fprintf(stderr, "%s: ", label);
+	for (i=0; i < len; i++) {
+		unsigned char c = (unsigned char) data[i];
+		fprintf(stderr, "%02x ", (int) c);
+		if ((i+1) % 20 == 0) {
+			fprintf(stderr, "\n%s: ", label);
+		}
+	}
+	fprintf(stderr, "\n");
+}
+
+#define DH_MAX_BITS 31
+static unsigned long long max_dh = ((unsigned long long) 1) << DH_MAX_BITS;
+
+static unsigned long long bytes_to_uint64(char *bytes) {
+	unsigned long long result = 0;
+	int i;
+
+	for (i=0; i < 8; i++) {
+		result <<= 8;
+		result += (unsigned char) bytes[i];
+	}
+	return result;
+}
+
+static void uint64_to_bytes(unsigned long long n, char *bytes) {
+	int i;
+
+	for (i=0; i < 8; i++) {
+		bytes[i] = (unsigned char) (n >> (8 * (7 - i)));
+	}
+}
+
+static void try_invert(char *wireuser, char *wirepass, unsigned long long actual_key) {
+	if (wireuser || wirepass || actual_key) {}
+	return;
+}
+
+
+static unsigned long long XpowYmodN(unsigned long long x, unsigned long long y, unsigned long long N) {
+	unsigned long long result = 1;
+	unsigned long long oneShift63 = ((unsigned long long) 1) << 63;
+	int i;
+
+	for (i = 0; i < 64; y <<= 1, i++) {
+		result = result * result % N;
+		if (y & oneShift63) {
+			result = result * x % N;
+		}
+	}
+	return result;
+}
+
+/*
+ * UltraVNC MS-Logon authentication (for v1.0.5 and later.)
+ */
+
+/*
+ * NOTE: The UltraVNC MS-Logon username and password exchange is
+ *       VERY insecure.  It can be brute forced in ~2e+9 operations.
+ *       It's not clear we should support it...  It is only worth using
+ *       in an environment where no one is sniffing the network, in which
+ *       case all of this DH exchange secrecy is unnecessary...
+ */
+
+static Bool AuthUltraVncMsLogon(void) {
+	CARD32 authResult;
+	char gen[8], mod[8], pub[8], rsp[8];
+	char user[256], passwd[64], *gpw;
+	unsigned char key[8];
+	unsigned long long ugen, umod, ursp, upub, uprv, ukey;
+	double now = dnow();
+	int db = 0;
+
+	if (getenv("SSVNC_DEBUG_MSLOGON")) {
+		db = atoi(getenv("SSVNC_DEBUG_MSLOGON"));
+	}
+
+	fprintf(stderr, "\nAuthUltraVncMsLogon()\n");
+
+	if (!ReadFromRFBServer(gen, sizeof(gen))) {
+		return False;
+	}
+	if (db) hexprint("gen", gen, sizeof(gen));
+
+	if (!ReadFromRFBServer(mod, sizeof(mod))) {
+		return False;
+	}
+	if (db) hexprint("mod", mod, sizeof(mod));
+	
+	if (!ReadFromRFBServer(rsp, sizeof(rsp))) {
+		return False;
+	}
+	if (db) hexprint("rsp", rsp, sizeof(rsp));
+
+	ugen = bytes_to_uint64(gen);
+	umod = bytes_to_uint64(mod);
+	ursp = bytes_to_uint64(rsp);
+
+	if (db) {
+		fprintf(stderr, "ugen: 0x%016llx %12llu\n", ugen, ugen);
+		fprintf(stderr, "umod: 0x%016llx %12llu\n", umod, umod);
+		fprintf(stderr, "ursp: 0x%016llx %12llu\n", ursp, ursp);
+	}
+
+	if (ugen > max_dh) {
+		fprintf(stderr, "ugen: too big: 0x%016llx\n", ugen);
+		return False;
+	}
+
+	if (umod > max_dh) {
+		fprintf(stderr, "umod: too big: 0x%016llx\n", umod);
+		return False;
+	}
+
+	/* make a random long long: */
+	uprv = 0xffffffff * (now - (unsigned int) now);
+	uprv = uprv << 32;
+	uprv |= (unsigned long long) urandom();
+	uprv = uprv % max_dh;
+
+	if (db) fprintf(stderr, "uprv: 0x%016llx %12llu\n", uprv, uprv);
+
+	upub = XpowYmodN(ugen, uprv, umod);
+
+	if (db) fprintf(stderr, "upub: 0x%016llx %12llu\n", upub, upub);
+
+	uint64_to_bytes(upub, pub);
+
+	if (db) hexprint("pub", pub, sizeof(pub));
+
+	if (!WriteExact(rfbsock, (char *)pub, sizeof(pub))) {
+		return False;
+	}
+	if (db) fprintf(stderr, "wrote pub.\n");
+
+	if (ursp > max_dh) {
+		fprintf(stderr, "ursp: too big: 0x%016llx\n", ursp);
+		return False;
+	}
+
+	ukey = XpowYmodN(ursp, uprv, umod);
+
+	if (db) fprintf(stderr, "ukey: 0x%016llx %12llu\n", ukey, ukey);
+
+	if (1)  {
+		char tmp[10000];
+		tmp[0] = '\0';
+		strcat(tmp, "\n");
+		strcat(tmp, "WARNING: The UltraVNC Diffie-Hellman Key is weak (key < 2e+9, i.e. 31 bits)\n");
+		strcat(tmp, "WARNING: and so an eavesdropper could recover your MS-Logon username and\n");
+		strcat(tmp, "WARNING: password via brute force in a few seconds of CPU time. \n");
+		strcat(tmp, "WARNING: If this connection is NOT being tunnelled through a separate SSL or\n");
+		strcat(tmp, "WARNING: SSH encrypted tunnel, consider things carefully before proceeding...\n");
+		strcat(tmp, "WARNING: Do not enter an important username+password when prompted below if\n");
+		strcat(tmp, "WARNING: there is a risk of an eavesdropper sniffing this connection.\n");
+		strcat(tmp, "WARNING: UltraVNC MSLogon encryption is VERY weak.  You've been warned!\n");
+		wmsg(tmp, 1);
+	}
+
+	uint64_to_bytes(ukey, (char *) key);
+
+	if (appData.msLogon == NULL || !strcmp(appData.msLogon, "1")) {
+		char tmp[256], *q, *s;
+		if (!use_tty()) {
+			fprintf(stderr, "\nEnter UltraVNC MS-Logon Username[@Domain] in the popup.\n");
+			s = DoUserDialog(); 
+		} else {
+			raiseme(1);
+			fprintf(stderr, "\nUltraVNC MS-Logon Username[@Domain]: ");
+			if (fgets(tmp, 256, stdin) == NULL) {
+				exit(1);
+			}
+			s = strdup(tmp);
+		}
+		q = strchr(s, '\n');
+		if (q) *q = '\0';
+		appData.msLogon = strdup(s);
+	}
+
+	if (!use_tty()) {
+		gpw = DoPasswordDialog(); 
+	} else {
+		raiseme(1);
+		gpw = getpass("UltraVNC MS-Logon Password: ");
+	}
+	if (! gpw) {
+		return False;
+	}
+	fprintf(stderr, "\n");
+
+	memset(user, 0, sizeof(user));
+	strncpy(user, appData.msLogon, 255);
+
+	memset(passwd, 0, sizeof(passwd));
+	strncpy(passwd, gpw, 63);
+
+	if (db > 1) {
+		fprintf(stderr, "user='%s'\n", user);
+		fprintf(stderr, "pass='%s'\n", passwd);
+	}
+
+	UvncEncryptBytes2((unsigned char *) user,   sizeof(user),   key);
+	UvncEncryptBytes2((unsigned char *) passwd, sizeof(passwd), key);
+
+	if (getenv("TRY_INVERT")) {
+		try_invert(user, passwd, ukey);
+		exit(0);
+	}
+
+	if (db) {
+		hexprint("user", user, sizeof(user));
+		hexprint("pass", passwd, sizeof(passwd));
+	}
+
+	if (!WriteExact(rfbsock, user, sizeof(user))) {
+		return False;
+	}
+	if (db) fprintf(stderr, "wrote user.\n");
+
+	if (!WriteExact(rfbsock, passwd, sizeof(passwd))) {
+		return False;
+	}
+	if (db) fprintf(stderr, "wrote passwd.\n");
+
+	if (!ReadFromRFBServer((char *) &authResult, 4)) {
+		return False;
+	}
+	authResult = Swap32IfLE(authResult);
+
+	if (db) fprintf(stderr, "authResult: %d\n", (int) authResult);
+
+	switch (authResult) {
+	case rfbVncAuthOK:
+		fprintf(stderr, "UVNC MS-Logon authentication succeeded.\n\n");
+		break;
+	case rfbVncAuthFailed:
+		fprintf(stderr, "UVNC MS-Logon authentication failed.\n");
+		if (viewer_minor >= 8) {
+			printFailureReason();
+		} else {
+			sprintf(msgbuf, "UVNC MS-Logon authentication failed.\n");
+			wmsg(msgbuf, 1);
+		}
+		fprintf(stderr, "\n");
+		return False;
+	case rfbVncAuthTooMany:
+		sprintf(msgbuf, "UVNC MS-Logon authentication failed - too many tries.\n\n");
+		wmsg(msgbuf, 1);
+		return False;
+	default:
+		sprintf(msgbuf, "Unknown UVNC MS-Logon authentication result: %d\n\n",
+		    (int)authResult);
+		wmsg(msgbuf, 1);
+		return False;
+	}
+
+	return True;
+}
 
 /*
  * Standard VNC authentication.
@@ -519,80 +1560,119 @@
 static Bool
 AuthenticateVNC(void)
 {
-  CARD32 authScheme, authResult;
-  CARD8 challenge[CHALLENGESIZE];
-  char *passwd;
-  char  buffer[64];
-  char* cstatus;
-  int   len;
+	CARD32 authScheme, authResult;
+	CARD8 challenge[CHALLENGESIZE];
+	char *passwd = NULL;
+	char  buffer[64];
+	char* cstatus;
+	int   len;
+	int restart = 0;
 
-  fprintf(stderr, "Performing standard VNC authentication\n");
+	if (authScheme) {}
 
-  if (!ReadFromRFBServer((char *)challenge, CHALLENGESIZE))
-    return False;
+	fprintf(stderr, "\nPerforming standard VNC authentication\n");
 
-  if (appData.passwordFile) {
-    passwd = vncDecryptPasswdFromFile(appData.passwordFile);
-    if (!passwd) {
-      fprintf(stderr, "Cannot read valid password from file \"%s\"\n",
-	      appData.passwordFile);
-      return False;
-    }
-  } else if (appData.autoPass) {
-    passwd = buffer;
-    cstatus = fgets(buffer, sizeof buffer, stdin);
-    if (cstatus == NULL)
-       buffer[0] = '\0';
-    else
-    {
-       len = strlen(buffer);
-       if (len > 0 && buffer[len - 1] == '\n')
-	  buffer[len - 1] = '\0';
-    }
-  } else if (appData.passwordDialog) {
-    passwd = DoPasswordDialog();
-  } else {
-    passwd = getpass("Password: ");
-  }
+	if (!ReadFromRFBServer((char *)challenge, CHALLENGESIZE)) {
+		return False;
+	}
+		
+	if (restart_session_pw != NULL) {
+		passwd = restart_session_pw;	
+		restart_session_pw = NULL;
+		restart = 1;
+	} else if (appData.passwordFile) {
+		passwd = vncDecryptPasswdFromFile(appData.passwordFile);
+		if (!passwd) {
+			sprintf(msgbuf, "Cannot read valid password from file \"%s\"\n", appData.passwordFile);
+			wmsg(msgbuf, 1);
+			return False;
+		}
+	} else if (appData.autoPass) {
+		passwd = buffer;
+		raiseme(1);
+		cstatus = fgets(buffer, sizeof buffer, stdin);
+		if (cstatus == NULL) {
+			buffer[0] = '\0';
+		} else {
+			len = strlen(buffer);
+			if (len > 0 && buffer[len - 1] == '\n') {
+				buffer[len - 1] = '\0';
+			}
+		}
+	} else if (getenv("VNCVIEWER_PASSWORD")) {
+		passwd = strdup(getenv("VNCVIEWER_PASSWORD"));
+	} else if (appData.passwordDialog || !use_tty()) {
+		passwd = DoPasswordDialog();
+	} else {
+		raiseme(1);
+		passwd = getpass("VNC Password: ");
+	}
 
-  if (!passwd || strlen(passwd) == 0) {
-    fprintf(stderr, "Reading password failed\n");
-    return False;
-  }
-  if (strlen(passwd) > 8) {
-    passwd[8] = '\0';
-  }
+	if (getenv("VNCVIEWER_PASSWORD")) {
+		putenv("VNCVIEWER_PASSWORD=none");
+	}
 
-  vncEncryptBytes(challenge, passwd);
+	if (restart) {
+#define EN0 0
+#define DE1 1
+		unsigned char s_fixedkey[8] = {23,82,107,6,35,78,88,7};
+		deskey(s_fixedkey, DE1);
+		des(passwd, passwd);
+	} else {
+		if (!passwd || strlen(passwd) == 0) {
+			sprintf(msgbuf, "Reading password failed\n\n");
+			wmsg(msgbuf, 1);
+			return False;
+		}
+		if (strlen(passwd) > 8) {
+			passwd[8] = '\0';
+		}
+	}
 
-  /* Lose the password from memory */
-  memset(passwd, '\0', strlen(passwd));
+	vncEncryptBytes(challenge, passwd);
+	
 
-  if (!WriteExact(rfbsock, (char *)challenge, CHALLENGESIZE))
-    return False;
 
-  if (!ReadFromRFBServer((char *)&authResult, 4))
-    return False;
+#if 0
+	/* Lose the password from memory */
+	memset(passwd, '\0', strlen(passwd));
+#endif
 
-  authResult = Swap32IfLE(authResult);
+	if (!WriteExact(rfbsock, (char *)challenge, CHALLENGESIZE)) {
+		return False;
+	}
 
-  switch (authResult) {
-  case rfbVncAuthOK:
-    fprintf(stderr, "VNC authentication succeeded\n");
-    break;
-  case rfbVncAuthFailed:
-    fprintf(stderr, "VNC authentication failed\n");
-    return False;
-  case rfbVncAuthTooMany:
-    fprintf(stderr, "VNC authentication failed - too many tries\n");
-    return False;
-  default:
-    fprintf(stderr, "Unknown VNC authentication result: %d\n",
-	    (int)authResult);
-    return False;
-  }
+	if (!ReadFromRFBServer((char *)&authResult, 4)) {
+		return False;
+	}
 
-  return True;
+	authResult = Swap32IfLE(authResult);
+
+	switch (authResult) {
+	case rfbVncAuthOK:
+		fprintf(stderr, "VNC authentication succeeded\n\n");
+		break;
+	case rfbVncAuthFailed:
+		fprintf(stderr, "VNC authentication failed.\n");
+		if (viewer_minor >= 8) {
+			printFailureReason();
+		} else {
+			sprintf(msgbuf, "VNC authentication failed.\n");
+			wmsg(msgbuf, 1);
+		}
+		fprintf(stderr, "\n");
+		return False;
+	case rfbVncAuthTooMany:
+		sprintf(msgbuf, "VNC authentication failed - too many tries\n\n");
+		wmsg(msgbuf, 1);
+		return False;
+	default:
+		sprintf(msgbuf, "Unknown VNC authentication result: %d\n\n", (int)authResult);
+		wmsg(msgbuf, 1);
+		return False;
+	}
+
+	return True;
 }
 
 /*
@@ -602,68 +1682,77 @@
 static Bool
 AuthenticateUnixLogin(void)
 {
-  CARD32 loginLen, passwdLen, authResult;
-  char *login;
-  char *passwd;
-  struct passwd *ps;
-
-  fprintf(stderr, "Performing Unix login-style authentication\n");
-
-  if (appData.userLogin) {
-    login = appData.userLogin;
-  } else {
-    ps = getpwuid(getuid());
-    login = ps->pw_name;
-  }
+	CARD32 loginLen, passwdLen, authResult;
+	char *login;
+	char *passwd;
+	struct passwd *ps;
+
+	fprintf(stderr, "\nPerforming Unix login-style authentication\n");
+
+	if (appData.userLogin) {
+		login = appData.userLogin;
+	} else {
+		ps = getpwuid(getuid());
+		login = ps->pw_name;
+	}
 
-  fprintf(stderr, "Using user name \"%s\"\n", login);
+	fprintf(stderr, "Using user name \"%s\"\n", login);
 
-  if (appData.passwordDialog) {
-    passwd = DoPasswordDialog();
-  } else {
-    passwd = getpass("Password: ");
-  }
-  if (!passwd || strlen(passwd) == 0) {
-    fprintf(stderr, "Reading password failed\n");
-    return False;
-  }
+	if (appData.passwordDialog || !use_tty()) {
+		passwd = DoPasswordDialog();
+	} else {
+		raiseme(1);
+		passwd = getpass("VNC Password: ");
+	}
+	if (!passwd || strlen(passwd) == 0) {
+		fprintf(stderr, "Reading password failed\n");
+		return False;
+	}
 
-  loginLen = Swap32IfLE((CARD32)strlen(login));
-  passwdLen = Swap32IfLE((CARD32)strlen(passwd));
+	loginLen = Swap32IfLE((CARD32)strlen(login));
+	passwdLen = Swap32IfLE((CARD32)strlen(passwd));
 
-  if (!WriteExact(rfbsock, (char *)&loginLen, sizeof(loginLen)) ||
-      !WriteExact(rfbsock, (char *)&passwdLen, sizeof(passwdLen)))
-    return False;
+	if (!WriteExact(rfbsock, (char *)&loginLen, sizeof(loginLen)) ||
+	    !WriteExact(rfbsock, (char *)&passwdLen, sizeof(passwdLen))) {
+		return False;
+	}
 
-  if (!WriteExact(rfbsock, login, strlen(login)) ||
-      !WriteExact(rfbsock, passwd, strlen(passwd)))
-    return False;
+	if (!WriteExact(rfbsock, login, strlen(login)) ||
+	    !WriteExact(rfbsock, passwd, strlen(passwd))) {
+		return False;
+	}
 
-  /* Lose the password from memory */
-  memset(passwd, '\0', strlen(passwd));
+#if 0
+	/* Lose the password from memory */
+	memset(passwd, '\0', strlen(passwd));
+#endif
 
-  if (!ReadFromRFBServer((char *)&authResult, sizeof(authResult)))
-    return False;
+	if (!ReadFromRFBServer((char *)&authResult, sizeof(authResult))) {
+		return False;
+	}
 
-  authResult = Swap32IfLE(authResult);
+	authResult = Swap32IfLE(authResult);
 
-  switch (authResult) {
-  case rfbVncAuthOK:
-    fprintf(stderr, "Authentication succeeded\n");
-    break;
-  case rfbVncAuthFailed:
-    fprintf(stderr, "Authentication failed\n");
-    return False;
-  case rfbVncAuthTooMany:
-    fprintf(stderr, "Authentication failed - too many tries\n");
-    return False;
-  default:
-    fprintf(stderr, "Unknown authentication result: %d\n",
-	    (int)authResult);
-    return False;
-  }
+	switch (authResult) {
+	case rfbVncAuthOK:
+		fprintf(stderr, "Authentication succeeded\n\n");
+		break;
+	case rfbVncAuthFailed:
+		sprintf(msgbuf, "Authentication failed\n\n");
+		wmsg(msgbuf, 1);
+		return False;
+	case rfbVncAuthTooMany:
+		sprintf(msgbuf, "Authentication failed - too many tries\n\n");
+		wmsg(msgbuf, 1);
+		return False;
+	default:
+		sprintf(msgbuf, "Unknown authentication result: %d\n\n",
+		    (int)authResult);
+		wmsg(msgbuf, 1);
+		return False;
+	}
 
-  return True;
+	return True;
 }
 
 
@@ -675,19 +1764,20 @@
 static Bool
 ReadInteractionCaps(void)
 {
-  rfbInteractionCapsMsg intr_caps;
+	rfbInteractionCapsMsg intr_caps;
 
-  /* Read the counts of list items following */
-  if (!ReadFromRFBServer((char *)&intr_caps, sz_rfbInteractionCapsMsg))
-    return False;
-  intr_caps.nServerMessageTypes = Swap16IfLE(intr_caps.nServerMessageTypes);
-  intr_caps.nClientMessageTypes = Swap16IfLE(intr_caps.nClientMessageTypes);
-  intr_caps.nEncodingTypes = Swap16IfLE(intr_caps.nEncodingTypes);
-
-  /* Read the lists of server- and client-initiated messages */
-  return (ReadCapabilityList(serverMsgCaps, intr_caps.nServerMessageTypes) &&
-	  ReadCapabilityList(clientMsgCaps, intr_caps.nClientMessageTypes) &&
-	  ReadCapabilityList(encodingCaps, intr_caps.nEncodingTypes));
+	/* Read the counts of list items following */
+	if (!ReadFromRFBServer((char *)&intr_caps, sz_rfbInteractionCapsMsg)) {
+		return False;
+	}
+	intr_caps.nServerMessageTypes = Swap16IfLE(intr_caps.nServerMessageTypes);
+	intr_caps.nClientMessageTypes = Swap16IfLE(intr_caps.nClientMessageTypes);
+	intr_caps.nEncodingTypes = Swap16IfLE(intr_caps.nEncodingTypes);
+
+	/* Read the lists of server- and client-initiated messages */
+	return (ReadCapabilityList(serverMsgCaps, intr_caps.nServerMessageTypes) &&
+		ReadCapabilityList(clientMsgCaps, intr_caps.nClientMessageTypes) &&
+		ReadCapabilityList(encodingCaps, intr_caps.nEncodingTypes));
 }
 
 
@@ -697,22 +1787,70 @@
  * many records to read from the socket.
  */
 
-static Bool
-ReadCapabilityList(CapsContainer *caps, int count)
-{
-  rfbCapabilityInfo msginfo;
-  int i;
+static Bool
+ReadCapabilityList(CapsContainer *caps, int count)
+{
+	rfbCapabilityInfo msginfo;
+	int i;
+
+	for (i = 0; i < count; i++) {
+		if (!ReadFromRFBServer((char *)&msginfo, sz_rfbCapabilityInfo)) {
+			return False;
+		}
+		msginfo.code = Swap32IfLE(msginfo.code);
+		CapsEnable(caps, &msginfo);
+	}
+
+	return True;
+}
+
 
-  for (i = 0; i < count; i++) {
-    if (!ReadFromRFBServer((char *)&msginfo, sz_rfbCapabilityInfo))
-      return False;
-    msginfo.code = Swap32IfLE(msginfo.code);
-    CapsEnable(caps, &msginfo);
-  }
+/* used to have !tunnelSpecified */
 
-  return True;
+static int guess_compresslevel(void) {
+	int n;
+	if (latency > 200.0) {
+		n = 8;
+	} else if (latency > 100.0) {
+		n = 7;
+	} else if (latency > 60.0) {
+		n = 6;
+	} else if (latency > 15.0) {
+		n = 4;
+	} else if (latency > 8.0) {
+		n = 2;
+	} else if (latency > 0.0) {
+		n = 1;
+	} else {
+		/* no latency measurement */
+		n = 3;
+	}
+	return n;
 }
 
+static int guess_qualitylevel(void) {
+	int n;
+	if (latency > 200.0) {
+		n = 4;
+	} else if (latency > 100.0) {
+		n = 5;
+	} else if (latency > 60.0) {
+		n = 6;
+	} else if (latency > 15.0) {
+		n = 7;
+	} else if (latency > 8.0) {
+		n = 8;
+	} else if (latency > 0.0) {
+		n = 9;
+	} else {
+		/* no latency measurement */
+		n = 6;
+	}
+#ifdef TURBOVNC
+	n *= 10;
+#endif
+	return n;
+}
 
 /*
  * SetFormatAndEncodings.
@@ -729,6 +1867,21 @@
   Bool requestCompressLevel = False;
   Bool requestQualityLevel = False;
   Bool requestLastRectEncoding = False;
+  Bool requestNewFBSizeEncoding = True;
+  Bool requestTextChatEncoding = True;
+  Bool requestSubsampLevel = False;
+  int dsm = 0;
+  int tQL, tQLmax = 9;
+  static int qlmsg = 0, clmsg = 0;
+#ifdef TURBOVNC
+	tQLmax = 100;
+#endif
+
+	if (requestTextChatEncoding || requestSubsampLevel || tQL) {}
+
+#if 0
+  fprintf(stderr, "SetFormatAndEncodings: sent_FBU state: %2d\n", sent_FBU);
+#endif
 
   spf.type = rfbSetPixelFormat;
   spf.format = myFormat;
@@ -736,15 +1889,32 @@
   spf.format.greenMax = Swap16IfLE(spf.format.greenMax);
   spf.format.blueMax = Swap16IfLE(spf.format.blueMax);
 
+
+  currentMsg = rfbSetPixelFormat;
   if (!WriteExact(rfbsock, (char *)&spf, sz_rfbSetPixelFormatMsg))
     return False;
 
   se->type = rfbSetEncodings;
   se->nEncodings = 0;
 
+  if (appData.ultraDSM) {
+  	dsm = 1;
+  }
+
   if (appData.encodingsString) {
     char *encStr = appData.encodingsString;
     int encStrLen;
+	if (strchr(encStr, ','))  {
+		char *p;
+		encStr = strdup(encStr);
+		p = encStr;
+		while (*p != '\0') {
+			if (*p == ',') {
+				*p = ' ';
+			}
+			p++;
+		}
+	}
     do {
       char *nextEncStr = strchr(encStr, ' ');
       if (nextEncStr) {
@@ -754,50 +1924,102 @@
 	encStrLen = strlen(encStr);
       }
 
+if (getenv("DEBUG_SETFORMAT")) {
+	fprintf(stderr, "encs: ");
+	write(2, encStr, encStrLen);
+	fprintf(stderr, "\n");
+}
+
       if (strncasecmp(encStr,"raw",encStrLen) == 0) {
 	encs[se->nEncodings++] = Swap32IfLE(rfbEncodingRaw);
       } else if (strncasecmp(encStr,"copyrect",encStrLen) == 0) {
 	encs[se->nEncodings++] = Swap32IfLE(rfbEncodingCopyRect);
-      } else if (strncasecmp(encStr,"tight",encStrLen) == 0) {
+      } else if (strncasecmp(encStr,"tight",encStrLen) == 0 && !dsm) {
 	encs[se->nEncodings++] = Swap32IfLE(rfbEncodingTight);
 	requestLastRectEncoding = True;
-	if (appData.compressLevel >= 0 && appData.compressLevel <= 9)
-	  requestCompressLevel = True;
-	if (appData.enableJPEG)
-	  requestQualityLevel = True;
+	if (appData.compressLevel >= 0 && appData.compressLevel <= 9) {
+		requestCompressLevel = True;
+        }
+	if (appData.enableJPEG) {
+		requestQualityLevel = True;
+        }
+#ifdef TURBOVNC
+	requestSubsampLevel = True;
+#endif
       } else if (strncasecmp(encStr,"hextile",encStrLen) == 0) {
 	encs[se->nEncodings++] = Swap32IfLE(rfbEncodingHextile);
-      } else if (strncasecmp(encStr,"zlib",encStrLen) == 0) {
+      } else if (strncasecmp(encStr,"zlib",encStrLen) == 0 && !dsm) {
 	encs[se->nEncodings++] = Swap32IfLE(rfbEncodingZlib);
-	if (appData.compressLevel >= 0 && appData.compressLevel <= 9)
-	  requestCompressLevel = True;
-      } else if (strncasecmp(encStr,"corre",encStrLen) == 0) {
+	if (appData.compressLevel >= 0 && appData.compressLevel <= 9) {
+		requestCompressLevel = True;
+	}
+      } else if (strncasecmp(encStr,"corre",encStrLen) == 0 && !dsm) {
 	encs[se->nEncodings++] = Swap32IfLE(rfbEncodingCoRRE);
       } else if (strncasecmp(encStr,"rre",encStrLen) == 0) {
 	encs[se->nEncodings++] = Swap32IfLE(rfbEncodingRRE);
+      } else if (strncasecmp(encStr,"zrle",encStrLen) == 0) {
+	encs[se->nEncodings++] = Swap32IfLE(rfbEncodingZRLE);
+#if DO_ZYWRLE
+      } else if (strncasecmp(encStr,"zywrle",encStrLen) == 0) {
+		int qlevel = appData.qualityLevel;
+		if (qlevel < 0 || qlevel > tQLmax) qlevel = guess_qualitylevel();
+		encs[se->nEncodings++] = Swap32IfLE(rfbEncodingZYWRLE);
+		requestQualityLevel = True;
+		if (qlevel < 3) {
+			zywrle_level = 3;
+		} else if (qlevel < 6) {
+			zywrle_level = 2;
+		} else {
+			zywrle_level = 1;
+		}
+#endif
       } else {
 	fprintf(stderr,"Unknown encoding '%.*s'\n",encStrLen,encStr);
+        if (dsm && strstr(encStr, "tight") == encStr) fprintf(stderr, "tight encoding does not yet work with ultraDSM, skipping it.\n");
+        if (dsm && strstr(encStr, "corre") == encStr) fprintf(stderr, "corre encoding does not yet work with ultraDSM, skipping it.\n");
+        if (dsm && strstr(encStr, "zlib" ) == encStr) fprintf(stderr, "zlib  encoding does not yet work with ultraDSM, skipping it.\n");
       }
 
       encStr = nextEncStr;
     } while (encStr && se->nEncodings < MAX_ENCODINGS);
 
     if (se->nEncodings < MAX_ENCODINGS && requestCompressLevel) {
-      encs[se->nEncodings++] = Swap32IfLE(appData.compressLevel +
-					  rfbEncodingCompressLevel0);
+	;
+    } else if (se->nEncodings < MAX_ENCODINGS) {
+	appData.compressLevel = guess_compresslevel();
+	if (clmsg++ == 0) fprintf(stderr, "guessed: -compresslevel %d\n", appData.compressLevel);
     }
+    encs[se->nEncodings++] = Swap32IfLE(appData.compressLevel + rfbEncodingCompressLevel0);
 
     if (se->nEncodings < MAX_ENCODINGS && requestQualityLevel) {
-      if (appData.qualityLevel < 0 || appData.qualityLevel > 9)
-        appData.qualityLevel = 5;
-      encs[se->nEncodings++] = Swap32IfLE(appData.qualityLevel +
-					  rfbEncodingQualityLevel0);
+	if (appData.qualityLevel < 0 || appData.qualityLevel > tQLmax) {
+		appData.qualityLevel = guess_qualitylevel();
+		if (qlmsg++ == 0) fprintf(stderr, "guessed: -qualitylevel  %d\n", appData.qualityLevel);
+	}
+    } else if (se->nEncodings < MAX_ENCODINGS) {
+	appData.qualityLevel = guess_qualitylevel();
+	if (qlmsg++ == 0) fprintf(stderr, "guessed: -qualitylevel  %d\n", appData.qualityLevel);
+    }
+#ifdef TURBOVNC
+    tQL = appData.qualityLevel / 10;
+    if (tQL < 0) tQL = 1;
+    if (tQL > 9) tQL = 9;
+    encs[se->nEncodings++] = Swap32IfLE(tQL + rfbEncodingQualityLevel0);
+    encs[se->nEncodings++] = Swap32IfLE(appData.qualityLevel + rfbJpegQualityLevel1 - 1);
+    if (se->nEncodings < MAX_ENCODINGS && requestSubsampLevel) {
+	if (appData.subsampLevel < 0 || appData.subsampLevel > TVNC_SAMPOPT - 1) {
+		appData.subsampLevel = TVNC_1X;
+	}
+	encs[se->nEncodings++] = Swap32IfLE(appData.subsampLevel + rfbJpegSubsamp1X);
     }
+#else
+    encs[se->nEncodings++] = Swap32IfLE(appData.qualityLevel + rfbEncodingQualityLevel0);
+#endif
 
     if (appData.useRemoteCursor) {
       if (se->nEncodings < MAX_ENCODINGS)
 	encs[se->nEncodings++] = Swap32IfLE(rfbEncodingXCursor);
-      if (se->nEncodings < MAX_ENCODINGS)
+      if (se->nEncodings < MAX_ENCODINGS && !appData.useX11Cursor)
 	encs[se->nEncodings++] = Swap32IfLE(rfbEncodingRichCursor);
       if (se->nEncodings < MAX_ENCODINGS)
 	encs[se->nEncodings++] = Swap32IfLE(rfbEncodingPointerPos);
@@ -806,10 +2028,16 @@
     if (se->nEncodings < MAX_ENCODINGS && requestLastRectEncoding) {
       encs[se->nEncodings++] = Swap32IfLE(rfbEncodingLastRect);
     }
-  }
-  else {
+
+    if (se->nEncodings < MAX_ENCODINGS && requestNewFBSizeEncoding) {
+      encs[se->nEncodings++] = Swap32IfLE(rfbEncodingNewFBSize);
+    }
+
+  } else {
+	/* DIFFERENT CASE */
+
     if (SameMachine(rfbsock)) {
-      if (!tunnelSpecified) {
+      if (!tunnelSpecified && appData.useRawLocal) {
 	fprintf(stderr,"Same machine: preferring raw encoding\n");
 	encs[se->nEncodings++] = Swap32IfLE(rfbEncodingRaw);
       } else {
